/* ============================================================= */
/*  Rob Hamerling's MAXIMUS download file scan and sort utility  */
/*  -> DOWNFPRO.H                                                */
/*  -> Function prototypes for 'global' functions                */
/*     that may be called from different reporting functions     */
/* ============================================================= */

char      *asciiz(char *);
void       block_title(FILE *, short int, char *, unsigned int);
unsigned int count_areas(DOWNPATH _HUGE *, short int);
unsigned long int count_bytes(DOWNPATH _HUGE *);
unsigned int count_files(DOWNPATH _HUGE *);
void       desc_part(FILE *, char *, unsigned int,
                     unsigned int, unsigned int);
char      *f_date(FDATE);
char      *f_time(FTIME);
char      *f_size_date(ULONG, FDATE, FDATE, FTIME);
char       file_age_ind(FDATE, FTIME);
void       file_incl(FILE *, unsigned int);
long       file_time(FDATE, FTIME);
void       insert_title(FILE *, char *[], int);
char      *next_word(char *);
FILECHAIN *new_acq(FILECHAIN *, FILECHAIN *);
unsigned int preproc_area(DOWNPATH _HUGE *,
                          FILECHAIN **, short int);
void       psort(FILECHAIN **, short int, short int,
                    int (*)(const void *, const void *));
void     sep_line(FILE *, char, unsigned short int,...);
void     show_help(void);
void     show_welcome(void);
void     signature(FILE *, char *);
int      sort_all(const void *, const void *);
int      sort_al2(const void *, const void *);
int      sort_akp(const void *, const void *);
int      sort_fil(const void *, const void *);
int      sort_gbl(const void *, const void *);
int      sort_new(const void *, const void *);
int      sort_summ(const void *, const void *);
char    *stripf(char *);
char    *strava(char *);
char    *strnblk(char *, short int, short int, short int);
short int strsubw(char *, char **, short int);
char    *sys_date(char *);
int      non_wild_init(short int, char *, char *);
int      wild_init(short int, char *, char *);
int      wild_comp(char *,char *);

#if defined(DEBUG)
  int dump_area_array(DOWNPATH _HUGE *, short int, char *);
  int dump_file_chain(FILECHAIN *, char *);
#endif

